/*
 * 
  L293D Dual Motor Driver Module (2 Motors)

  Parts required:
  - Arduino Board
  - L293D Dual Motor Driver Module (2 Motors)
  - Motor
  - Power supply

  Programming by René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 19 Mar 2020
  Version : v1.0

  Alle dele kan købes på www.arduinotech.dk

*/

int motorAPin_IN4 = 2;                           // set digital port 2 to motor A direction    
int motorAPin_IN3 = 3;                           // set digital port 3 to motor A speed        
int motorBPin_IN2 = 4;                           // set digital port 4 motor B direction    
int motorBPin_IN1 = 5;                           // set digital port 5 motor B speed        

void setup() {
  pinMode(motorAPin_IN4, OUTPUT);                // set motorAPin_IN4 to OUTPUT
  pinMode(motorAPin_IN3, OUTPUT);                // set motorAPin_IN3 to OUTPUT
  pinMode(motorBPin_IN2, OUTPUT);                // set motorBPin_IN2 to OUTPUT
  pinMode(motorBPin_IN1, OUTPUT);                // set motorBPin_IN1 to OUTPUT
}

void loop() {

  // Motor A (Clockwise)
  digitalWrite(motorAPin_IN4, HIGH);             // set motor A to rotate clockwise

  for (int value = 255; value >= 0; value--) {   // set motor A speed value from 255 to 0 do
    analogWrite(motorAPin_IN3, value);           // set motor A speed
    delay(40);                                   // wait 40 ms
  }
  analogWrite(motorAPin_IN3, 255);               // set motor A to full stop

  delay(3000);                                   // wait 3000 ms

  // Motor A (Anti Clockwise)
  digitalWrite(motorAPin_IN4, LOW);              // set motor A to rotate anti clockwise

  for (int value = 0; value <= 255; value++) {   // set motor A speed value from 0 to 255 do
    analogWrite(motorAPin_IN3, value);           // set motor A speed
    delay(40);                                   // wait 40 ms
  }
  analogWrite(motorAPin_IN3, 0);                 // set motor A to full stop

  delay(3000);                                   // wait 3000 ms

  // Motor B (Clockwise)
  digitalWrite(motorBPin_IN2, HIGH);             // set motor B to rotate anti clockwise

  for (int value = 255; value >= 0; value--) {   // set motor B speed value from 255 to 0 do
    analogWrite(motorBPin_IN1, value);           // set motor B speed
    delay(40);                                   // wait 40 ms
  }
  analogWrite(motorBPin_IN1, 255);               // set motor B to full stop

  delay(3000);                                   // wait 3000 ms

  // Motor B (Anti Clockwise)
  digitalWrite(motorBPin_IN2, LOW);              // set motor B to rotate clockwise

  for (int value = 0; value <= 255; value++) {   // set motor B speed value from 0 to 255 do
    analogWrite(motorBPin_IN1, value);           // set motor B speed
    delay(40);                                   // wait 40 ms
  }
  analogWrite(motorBPin_IN1, 0);                 // set motor B to full stop

  delay(3000);                                   // wait 3000 ms
}
